.\"	$NetBSD: compat_sunos.8,v 1.18 2003/12/10 12:06:25 agc Exp $
.\"
.\" Copyright (c) 1984 Theo de Raadt
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd February 3, 2001
.Dt COMPAT_SUNOS 8
.Os
.Sh NAME
.Nm compat_sunos
.Nd setup procedure for m68k, sparc and sparc64 architectures
.Sh DESCRIPTION
.Nx Ns Tn /sparc64 ,
.Nx Ns Tn /sparc
and some of the
.Nx Ns Tn /m68k
architectures can run
.Tn SunOS
executables.  Most executables will work.
.Pp
The exceptions include programs that use the
.Tn SunOS
kvm library,
and various system calls,
.Fn ioctl Ns 's ,
or kernel semantics that are difficult to emulate.
The number of reasons why a program might fail to work is (thankfully)
longer than the number of programs that fail to run.
.Pp
Static executables will normally run without any extra setup.
This procedure details the directories and files that must be
set up to allow dynamically linked executables to work.
.Pp
The files you need are on your
.Tn SunOS
machine.
You need to worry about the legal issues of ensuring that you
have a right to use the required files on your machine.
On your
.Nx
machine, do the following:
.Bl -enum -offset 123
.It
.Li mkdir -p /emul/sunos/usr/lib /emul/sunos/usr/5lib
.It
.Li cp SunOS:/usr/lib/lib*.so.*.* NetBSD:/emul/sunos/usr/lib
.It
.Li cp SunOS:/usr/5lib/lib*.so.*.* NetBSD:/emul/sunos/usr/5lib
.It
.Li cp SunOS:/usr/lib/ld.so NetBSD:/emul/sunos/usr/lib/ld.so
.It
If you ever expect to use YP, you will want to create a link:
.Bd -literal -compact
ln -s /var/run/ypbind.lock /etc/ypbind.lock
.Ed
.El
.Pp
Alternatively, you can use an NFS mount to accomplish the same
effect.
On your
.Nx
machine, do the following:
.Bl -enum -offset 123
.It
.Li mkdir -p /emul/sunos/usr
.It
.Li mount SunOS:/usr /emul/sunos/usr
.El
.Pp
This will place the
.Tn SunOS
libraries on your
.Nx
machine
in a location where the
.Tn SunOS
compatibility code will look for
first, where they do not conflict with the standard libraries.
.Sh NOTES
When using
.Nm
on
.Nx Ns Tn /sparc64 ,
the
.Dv COMPAT_NETBSD32
option must also be used.
.Sh BUGS
A list of things which fail to work in compatibility mode should
be here.
.Pp
.Tn SunOS
executables can not handle directory offset cookies \*[Gt] 32 bits.
Should such an offset occur, you will see the message
.Dq sunos_getdents: dir offset too large for emulated program .
Currently, this can only
happen on NFS mounted filesystems, mounted from servers that return
offsets with information in the upper 32 bits. These errors should
rarely happen, but can be avoided by mounting this filesystem with offset
translation enabled. See the
.Fl X
option to
.Xr mount_nfs 8 .
The
.Fl 2
option to
.Xr mount_nfs 8
will also have the desired effect, but is less preferable.
.Pp
The
.Nx Ns Tn /sparc64
support is less complete than the other ports.
